"use strict";

var _mergeWith2 = _interopRequireDefault(require("lodash/mergeWith"));

var _helper = _interopRequireDefault(require("./helper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isArray = Array.isArray;

function merge(...configs) {
  if (configs && configs.length === 1) {
    if (isArray(configs[0])) {
      return (0, _mergeWith2.default)({}, ...configs[0], (0, _helper.default)(configs[0]));
    }

    if (configs[0].arrayCustomizer || configs[0].objectCustomizer) {
      return (...cfgs) => {
        if (cfgs && cfgs.length === 1 && isArray(cfgs[0])) {
          return (0, _mergeWith2.default)({}, ...cfgs[0], (0, _helper.default)(configs[0]));
        }

        return (0, _mergeWith2.default)({}, ...cfgs, (0, _helper.default)(configs[0]));
      };
    }

    return configs[0];
  }

  return (0, _mergeWith2.default)({}, ...configs, (0, _helper.default)());
}

const extendCustomizers = {
  arrayCustomizer(arr1, arr2) {
    return (0, _mergeWith2.default)([], arr2 || arr1, (0, _helper.default)(extendCustomizers));
  },

  objectCustomizer(obj1, obj2) {
    return (0, _mergeWith2.default)({}, obj2 || obj1, (0, _helper.default)(extendCustomizers));
  }

};

function extend(...configs) {
  return merge(extendCustomizers)({}, ...configs);
}

module.exports = merge;
module.exports.extend = extend;